#############################################################################################
#                                                                                           #
#                   Copyright 2010-2013 Ning, Inc.                                          #
#                   Copyright 2014 Groupon, Inc.                                            #
#                   Copyright 2014 The Billing Project, LLC                                 #
#                                                                                           #
#      The Billing Project licenses this file to you under the Apache License, version 2.0  #
#      (the "License"); you may not use this file except in compliance with the             #
#      License.  You may obtain a copy of the License at:                                   #
#                                                                                           #
#          http://www.apache.org/licenses/LICENSE-2.0                                       #
#                                                                                           #
#      Unless required by applicable law or agreed to in writing, software                  #
#      distributed under the License is distributed on an "AS IS" BASIS, WITHOUT            #
#      WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the            #
#      License for the specific language governing permissions and limitations              #
#      under the License.                                                                   #
#                                                                                           #
#############################################################################################


#
#                       DO NOT EDIT!!!
#    File automatically generated by killbill-java-parser (git@github.com:killbill/killbill-java-parser.git)
#


module Killbill
  module Plugin
    module Api

      java_package 'org.killbill.billing.overdue.api'
      class OverdueApi

        include org.killbill.billing.overdue.api.OverdueApi

        def initialize(real_java_api)
          @real_java_api = real_java_api
        end


        java_signature 'Java::org.killbill.billing.overdue.api.OverdueConfig getOverdueConfig(Java::org.killbill.billing.util.callcontext.TenantContext)'
        def get_overdue_config(context)

          # conversion for context [type = org.killbill.billing.util.callcontext.TenantContext]
          context = context.to_java unless context.nil?
          begin
            res = @real_java_api.get_overdue_config(context)
            # conversion for res [type = org.killbill.billing.overdue.api.OverdueConfig]
            res = Killbill::Plugin::Model::OverdueConfig.new.to_ruby(res) unless res.nil?
            return res
          rescue Java::org.killbill.billing.overdue.api.OverdueApiException => e
            raise Killbill::Plugin::Model::OverdueApiException.new.to_ruby(e)
          end
        end

        java_signature 'Java::void uploadOverdueConfig(Java::java.lang.String, Java::org.killbill.billing.util.callcontext.CallContext)'
        def upload_overdue_config(overdueXML, context)

          # conversion for overdueXML [type = java.lang.String]
          overdueXML = overdueXML.to_s unless overdueXML.nil?

          # conversion for context [type = org.killbill.billing.util.callcontext.CallContext]
          context = context.to_java unless context.nil?
          @real_java_api.upload_overdue_config(overdueXML, context)
        end

        java_signature 'Java::org.killbill.billing.overdue.api.OverdueState getOverdueStateFor(Java::java.util.UUID, Java::org.killbill.billing.util.callcontext.TenantContext)'
        def get_overdue_state_for(accountId, context)

          # conversion for accountId [type = java.util.UUID]
          accountId = java.util.UUID.fromString(accountId.to_s) unless accountId.nil?

          # conversion for context [type = org.killbill.billing.util.callcontext.TenantContext]
          context = context.to_java unless context.nil?
          begin
            res = @real_java_api.get_overdue_state_for(accountId, context)
            # conversion for res [type = org.killbill.billing.overdue.api.OverdueState]
            res = Killbill::Plugin::Model::OverdueState.new.to_ruby(res) unless res.nil?
            return res
          rescue Java::org.killbill.billing.overdue.api.OverdueApiException => e
            raise Killbill::Plugin::Model::OverdueApiException.new.to_ruby(e)
          end
        end
      end
    end
  end
end
